# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_cmx_lib.api_client import ApiClient


class VSphereEndpointsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_full_virtual_machine_classes(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get full information about all virtual machine classes for a vSphere endpoint  # noqa: E501

        Get all virtual machine classes defined in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_full_virtual_machine_classes(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[InlineResponse20015]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_full_virtual_machine_classes_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_full_virtual_machine_classes_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
            return data

    def get_full_virtual_machine_classes_with_http_info(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get full information about all virtual machine classes for a vSphere endpoint  # noqa: E501

        Get all virtual machine classes defined in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_full_virtual_machine_classes_with_http_info(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[InlineResponse20015]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_full_virtual_machine_classes" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_self_link_id' is set
        if ('endpoint_self_link_id' not in params or
                params['endpoint_self_link_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_self_link_id` when calling `get_full_virtual_machine_classes`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_self_link_id' in params:
            path_params['endpointSelfLinkId'] = params['endpoint_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/vsphere/endpoints/{endpointSelfLinkId}/virtual-machine-classes-described', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[InlineResponse20015]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_storage_classes(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all storage classes identifiers for a vSphere endpoint  # noqa: E501

        Get all storage classes defined in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id. This method is Deprecated. Instead, use /storage-classes from Vcenter Endpoints  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_storage_classes(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_storage_classes_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_storage_classes_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
            return data

    def get_storage_classes_with_http_info(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all storage classes identifiers for a vSphere endpoint  # noqa: E501

        Get all storage classes defined in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id. This method is Deprecated. Instead, use /storage-classes from Vcenter Endpoints  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_storage_classes_with_http_info(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_storage_classes" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_self_link_id' is set
        if ('endpoint_self_link_id' not in params or
                params['endpoint_self_link_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_self_link_id` when calling `get_storage_classes`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_self_link_id' in params:
            path_params['endpointSelfLinkId'] = params['endpoint_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/vsphere/endpoints/{endpointSelfLinkId}/storage-classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_tanzu_kubernetes_releases(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all tanzu kubernetes releases identifiers for a vSphere endpoint  # noqa: E501

        Get all tanzu kubernetes releases supported in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tanzu_kubernetes_releases(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_tanzu_kubernetes_releases_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_tanzu_kubernetes_releases_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
            return data

    def get_tanzu_kubernetes_releases_with_http_info(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all tanzu kubernetes releases identifiers for a vSphere endpoint  # noqa: E501

        Get all tanzu kubernetes releases supported in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_tanzu_kubernetes_releases_with_http_info(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_tanzu_kubernetes_releases" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_self_link_id' is set
        if ('endpoint_self_link_id' not in params or
                params['endpoint_self_link_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_self_link_id` when calling `get_tanzu_kubernetes_releases`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_self_link_id' in params:
            path_params['endpointSelfLinkId'] = params['endpoint_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/vsphere/endpoints/{endpointSelfLinkId}/tanzu-kubernetes-releases', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_virtual_machine_classes(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all virtual machine classes names for a vSphere endpoint  # noqa: E501

        Get all virtual machine classes defined in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_virtual_machine_classes(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_virtual_machine_classes_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_virtual_machine_classes_with_http_info(endpoint_self_link_id, **kwargs)  # noqa: E501
            return data

    def get_virtual_machine_classes_with_http_info(self, endpoint_self_link_id, **kwargs):  # noqa: E501
        """Get all virtual machine classes names for a vSphere endpoint  # noqa: E501

        Get all virtual machine classes defined in all managed supervisor clusters in a particular vSphere instance. vSphere instance is identified by endpoint SelfLink Id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_virtual_machine_classes_with_http_info(endpoint_self_link_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str endpoint_self_link_id: (required)
        :return: list[str]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['endpoint_self_link_id']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_virtual_machine_classes" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'endpoint_self_link_id' is set
        if ('endpoint_self_link_id' not in params or
                params['endpoint_self_link_id'] is None):
            raise ValueError("Missing the required parameter `endpoint_self_link_id` when calling `get_virtual_machine_classes`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'endpoint_self_link_id' in params:
            path_params['endpointSelfLinkId'] = params['endpoint_self_link_id']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['bearerAuth']  # noqa: E501

        return self.api_client.call_api(
            '/cmx/api/resources/vsphere/endpoints/{endpointSelfLinkId}/virtual-machine-classes', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='list[str]',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
